#!/bin/sh
. `dirname $0`/func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param

echo " ================================================================================="
echo " starting gstreamer with Monochrome Source ..."
echo " read $SENSOR_RES (offset x,y=$OFFSET_SENSOR) and write to file bw_$CAMERA_TYP.raw"
echo " ====================================================================================="
echo ""
echo " configure CSI1 (CAM1 port) with media_control"
echo " ================================================"

media-ctl -r
if [ "$PHYCAML" = "0" ]; then
	media-ctl -l "'${CAM_ENTITY_NAME}':0->'imx7-mipi-csis.0':0[1]"
#           Camera -> imx7_mipi_csis.0 -> CSI -> CSI capture (/dev/videoX)

	media-ctl -V "'${CAM_ENTITY_NAME}':0 [fmt:${CAM_BW_FMT}/${SENSOR_RES} ${OFFSET_SENSOR}/${SENSOR_RES}]"
	media-ctl -V "'imx7-mipi-csis.0':0 [fmt:${CAM_BW_FMT}/${SENSOR_RES}]"
	media-ctl -V "'csi':0 [fmt:${CAM_BW_FMT}/${SENSOR_RES} field:none]"
else
	media-ctl -l "'ds90ub953 4-0018':1->'ds90ub954 3-003d':0[1]"
	media-ctl -l "'ds90ub954 3-003d':2->'imx7-mipi-csis.0':0[1]"
#           Camera -> DS90ub953 -> DS90ub954 ->imx7_mipi_csis.0 -> CSI -> CSI capture (/dev/videoX)

	media-ctl -V "'${CAM_ENTITY_NAME}':0 [fmt:${CAM_BW_FMT}/${SENSOR_RES} ${OFFSET_SENSOR}/${SENSOR_RES}]"
	media-ctl -V "'imx7-mipi-csis.0':0 [fmt:${CAM_BW_FMT}/${SENSOR_RES}]"
	media-ctl -V "'csi':0 [fmt:${CAM_BW_FMT}/${SENSOR_RES} field:none]"
fi


$V4L2_CTRL_CAM1_BW


echo ""
echo " start gstreamer"
echo " ==============="

gst-launch-1.0 \
	v4l2src num-buffers=$NUMBER_OF_PIC device=$VID_DEVICE ! \
	video/x-raw,format=GRAY8,depth=8,$FRAME_SIZE ! \
	multifilesink location=bw_$CAMERA_TYP.raw

echo "File \"bw_$CAMERA_TYP.raw\" (Y8$SENSOR_SIZE)"