#!/bin/sh
# i.MX 8M Mini, version V3.0, Phytec 07.2023

init_dev() {

echo " ====================================================================="

VID_DEVICE=`v4l2-ctl --list-devices | grep -C1 csi | grep video | cut -c 2-`
CAM_ENTITY_NAME="$(cat /sys/class/video4linux/v4l-subdev2/name)"
CAM_DRIVER="$(echo ${CAM_ENTITY_NAME} | cut -d" " -f1)"
CAM_I2C_BUS="$(echo ${CAM_ENTITY_NAME} | cut -d" " -f2 | cut -b1)"
CAM_I2C_ADRESS="$(echo ${CAM_ENTITY_NAME} | cut -d" " -f2 | cut -b4-6)"
CAM_DEVICE=$(media-ctl -e "$CAM_DRIVER $CAM_I2C_BUS-0$CAM_I2C_ADRESS")


if [ $CAM_DRIVER = "ar0144" ]; then
	source /usr/share/phytec-gstreamer-examples/ar0144.conf
elif [ $CAM_DRIVER = "ar0521" ]; then
	source /usr/share/phytec-gstreamer-examples/ar0521.conf
elif [ $CAM_DRIVER = "ar0234" ]; then
        source /usr/share/phytec-gstreamer-examples/ar0234.conf
else
	echo ""
	echo " camera at CAM1 connector not found"
	echo " no camera or more then one camera connected"
	echo " please check camera device tree"
	echo " please check connected camera type, i2c adress and cable connections"
	echo ""
	return 1
fi

if [ "`media-ctl -p | grep -C1 "entity ..: ds90ub953"`" = "" ]; then
	PHYCAML="0"
else
	PHYCAML="1"
fi


echo ""
echo " camera = $CAMERA_TYP at i2c bus=$CAM_I2C_BUS with i2c adress=0x$CAM_I2C_ADRESS installed"
echo " capture device @CAM1 = $VID_DEVICE"
echo " camera device @CAM1 = $CAM_DEVICE"
echo " camera entity name = $CAM_ENTITY_NAME"
echo " camera driver = $CAM_DRIVER"
echo ""

return 0
}