#!/bin/sh
. `dirname $0`/../func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param

SENSOR_RES_ROI="800x480"
FRAME_SIZE_ROI="width=800,height=480"
OFFSET_SENSOR="(240,164)"

echo " ================================================================================="
echo " starting gstreamer with $CAM_COL_FORMAT Source ..."
echo " read $SENSOR_RES_ROI (ROI in center of pic) convert bayer2rgb and write to framebuffer $SENSOR_RES_ROI"
echo " ================================================================================================"
echo ""
echo " configure CSI1 (CAM1 port) with media_control"
echo " ================================================"

media-ctl -r
if [ "$PHYCAML" = "0" ]; then
	media-ctl -l "'${CAM_ENTITY_NAME}':0->'imx7-mipi-csis.0':0[1]"
#           Camera -> imx7_mipi_csis.0 -> CSI -> CSI capture (/dev/videoX)

	media-ctl -V "'${CAM_ENTITY_NAME}':0 [fmt:${CAM_COL_FMT}/${SENSOR_RES_ROI} ${OFFSET_SENSOR}/${SENSOR_RES_ROI}]"
	media-ctl -V "'imx7-mipi-csis.0':0 [fmt:${CAM_COL_FMT}/${SENSOR_RES_ROI}]"
	media-ctl -V "'csi':0 [fmt:${CAM_COL_FMT}/${SENSOR_RES_ROI} field:none]"
else
	media-ctl -l "'ds90ub953 4-0018':1->'ds90ub954 3-003d':0[1]"
	media-ctl -l "'ds90ub954 3-003d':2->'imx7-mipi-csis.0':0[1]"
#           Camera -> DS90ub953 -> DS90ub954 ->imx7_mipi_csis.0 -> CSI -> CSI capture (/dev/videoX)

	media-ctl -V "'${CAM_ENTITY_NAME}':0 [fmt:${CAM_COL_FMT}/${SENSOR_RES_ROI} ${OFFSET_SENSOR}/${SENSOR_RES_ROI}]"
	media-ctl -V "'imx7-mipi-csis.0':0 [fmt:${CAM_COL_FMT}/${SENSOR_RES_ROI}]"
	media-ctl -V "'csi':0 [fmt:${CAM_COL_FMT}/${SENSOR_RES_ROI} field:none]"
fi


echo ""
echo " configure camera @CAM1 with v4l2_control"
echo " ========================================"

v4l2-ctl -d $CAM_DEVICE -c auto_exposure_max=480
v4l2-ctl -d $CAM_DEVICE -c dynamic_defect_pixel_correction=0


echo ""
echo " start gstreamer, break with ctl-C"
echo " ================================="

gst-launch-1.0 \
	v4l2src device=$VID_DEVICE ! \
	video/x-$COL_FORMAT,$FRAME_SIZE_ROI ! \
	bayer2rgbneon ! \
	waylandsink sync=false
#	fbdevsink sync=false																	# disable Wayland/Weston
#	kmssink driver-name="imx-drm" force-modesetting=false can-scale=false sync=false		# disable Wayland/Weston
#	waylandsink sync=false																	# enable Wayland/Weston

v4l2-ctl -d $CAM_DEVICE -c auto_exposure_max=800
