#!/bin/sh
. `dirname $0`/../func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param

HOST_IP="192.168.2.67"
echo ""
echo " Attention: Before start the script, set the right IP address for you Host!"
echo " In the moment is set HOST IP = $HOST_IP"
echo " =========================================================================="

echo ""
echo " Show the stream on HOST e.g with VLC-Player. Start the SDP-FILE"
echo " Note: Set the Device IP address in the VLC-SDP File!"
echo ""

echo " starting gstreamer with COLOR (BAYER, YUV or RGB depend of camera typ) Source ..."
echo " read $GRAB_RES (offset x,y=$OFFSET_SENSOR), convert/compress H264 and write to network"
echo " =============================================================================="
echo ""
echo " configure CSI1 (CAM1 port) with media_control"
echo " ================================================"

media-ctl -r
if [ "$PHYCAML" = "0" ]; then
	media-ctl -l "'${CAM_ENTITY_NAME}':0->'imx7-mipi-csis.0':0[1]"
#           Camera -> imx7_mipi_csis.0 -> CSI -> CSI capture (/dev/videoX)

	media-ctl -V "'${CAM_ENTITY_NAME}':0 [fmt:${CAM_COL_FMT}/${SENSOR_RES_HD} ${OFFSET_SENSOR_HD}/${SENSOR_ARRAY_HD}]"
	media-ctl -V "'imx7-mipi-csis.0':0 [fmt:${CAM_COL_FMT}/${SENSOR_RES_HD}]"
	media-ctl -V "'csi':0 [fmt:${CAM_COL_FMT}/${SENSOR_RES_HD} field:none]"
else
	media-ctl -l "'ds90ub953 4-0018':1->'ds90ub954 3-003d':0[1]"
	media-ctl -l "'ds90ub954 3-003d':2->'imx7-mipi-csis.0':0[1]"
#           Camera -> DS90ub953 -> DS90ub954 ->imx7_mipi_csis.0 -> CSI -> CSI capture (/dev/videoX)

	media-ctl -V "'${CAM_ENTITY_NAME}':0 [fmt:${CAM_COL_FMT}/${SENSOR_RES_HD} ${OFFSET_SENSOR_HD}/${SENSOR_ARRAY_HD}]"
	media-ctl -V "'imx7-mipi-csis.0':0 [fmt:${CAM_COL_FMT}/${SENSOR_RES_HD}]"
	media-ctl -V "'csi':0 [fmt:${CAM_COL_FMT}/${SENSOR_RES_HD} field:none]"
fi


echo ""
echo " configure camera @CAM1 with v4l2_control"
echo " ========================================"

$V4L2_CTRL_CAM1_COL


echo ""
echo " start gstreamer, break with ctl-C"
echo " ================================="

gst-launch-1.0 \
	v4l2src device=$VID_DEVICE ! \
	video/x-$COL_FORMAT,$FRAME_SIZE_HD ! \
	videorate ! video/x-$COL_FORMAT,framerate=25/1 ! \
	bayer2rgbneon ! \
	queue ! vpuenc_h264 ! rtph264pay ! \
	udpsink host=$HOST_IP port=5200 sync=false

#	matroskamux ! filesink location=capture_H264.mkv

